package uniquenumbers;

import java.io.File;
import java.util.Arrays;
import java.util.Scanner;
import java.util.TreeSet;

public class UniqueNumbers {

    public static int[] readNumbers(String fileName) {
        Scanner input = null;
        try {
            input = new Scanner(new File(fileName));
        } catch (Exception ex) {
            System.out.println("Could not open file.");
            System.exit(1);
        }
        
        int numbers[] = new int[1000];
        
        for(int n = 0;n < 1000;n++)
            numbers[n] = input.nextInt();
        
        input.close();
        return numbers;
    }
    
    public static int[] removeDuplicates(int A[]) {
        // Sort the list to make our work easier
        Arrays.sort(A);
        // Count the number of unique numbers in A
        int count = 1;
        for(int n = 1;n < A.length;n++) {
            if(A[n-1] != A[n])
                count++;
        }
        // Create the result array, and copy numbers over to it.
        int B[] = new int[count];
        B[0] = A[0];
        int k = 1;
        for(int n = 1;n < A.length;n++) {
            if(A[n-1] != A[n]) {
                B[k] = A[n];
                k++;
            }
        }
        return B;
    }
    
    public static int[] removeDups(int A[]) {
        // Collect information on how many times each of the numbers in A appears
        int counts[] = new int[1000];
        for(int n = 0;n < counts.length;n++)
            counts[n] = 0;
        for(int n = 0;n < A.length;n++)
            counts[A[n]]++;
        // Now use this count information to count how many unique numbers 
        // were in A
        int count = 0;
        for(int n = 0;n < counts.length;n++)
            if(counts[n] > 0)
                count++;
        // Construct the result list and copy numbers over to it
        int B[] = new int[count];
        int k = 0;
        for(int n = 0;n < counts.length;n++)
            if(counts[n] > 0) {
                B[k] = n;
                k++;
            }
        return B;
    }
    
    public static int[] removeDupsWithSet(int A[]) {
        TreeSet<Integer> set = new TreeSet<Integer>();
        for(int n = 0;n < A.length;n++)
            set.add(A[n]);
        int B[] = new int[set.size()];
        int k = 0;
        for(int x : set) {
            B[k] = x;
            k++;
        }
        return B;
    }
    
    public static void main(String[] args) {
        int A[] = readNumbers("numbers.txt");
        int B[] = removeDuplicates(A);
        for(int n = 0;n < B.length;n++)
            System.out.println(B[n]);
    }
    
}
